"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const ImageButton_1 = __importDefault(require("./ImageButton"));
const SceneUtils_1 = __importDefault(require("../utils/SceneUtils"));
const CheckSelected = require("../assets/images/check_selected.png");
const BottomPopupSize = (object) => {
    const { onHeaderItemClickSize, onCrossPress, onSizeClicked, data, sizeDetails, sizeDetailsIndex, showSizeDetails, firstLaunch, goToBodyShape, dismissPopup, itemTypes, itemTypeList, itemCat, modelSize, selectedSize, nobodyDetailsSavedBool } = object;
    const renderHeader = () => (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_native_1.View, { style: styles.headerContainer },
            react_1.default.createElement(react_native_1.Text, { style: {
                    fontSize: 14,
                    fontFamily: SceneUtils_1.default.whitney_semibold,
                    color: SceneUtils_1.default.text_color,
                    paddingTop: 18,
                    paddingBottom: 18,
                    paddingLeft: 22,
                    paddingRight: 12,
                    borderBottomColor: SceneUtils_1.default.primary_color,
                    borderBottomWidth: 2,
                    flex: 1
                } }, nobodyDetailsSavedBool ? 'Size' : 'Select size to see how it looks'),
            react_1.default.createElement(ImageButton_1.default, { imagepath: require("../assets/images/letter-x.png"), width: 15, height: 15, marginRight: 10, marginBottom: 10, onPress: onCrossPress })),
        react_1.default.createElement(react_native_1.View, { style: { backgroundColor: "rgba(255,255,255,0.9)" } },
            renderSeperator(),
            react_1.default.createElement(react_native_1.View, { style: { flexDirection: 'row' } }, renderSize()))));
    const renderSeperator = () => react_1.default.createElement(react_native_1.View, { style: styles.seperator });
    const renderSize = () => (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_native_1.View, { style: nobodyDetailsSavedBool || data.filter((c) => sizeDetails && sizeDetails[0] && sizeDetails[0].split(';').indexOf(c) < 0).length === 0 ? [styles.sizeListTrialContainer, { flex: 0.6 }] : [styles.sizeListTrialContainer, { borderRightWidth: 1, borderRightColor: 'rgba(151,151,151,0.4)' }] },
            react_1.default.createElement(react_native_1.Text, { style: styles.sizeListLabel }, nobodyDetailsSavedBool ? 'Model wearing size' : 'Available for trial'),
            react_1.default.createElement(react_native_1.FlatList, { data: sizeDetails && sizeDetails[0] && sizeDetails[0].split(';').filter((e) => e !== 'NA'), style: {
                    marginTop: 10,
                    flex: 1
                }, initialScrollIndex: sizeDetails[sizeDetailsIndex] && sizeDetails[sizeDetailsIndex].split(';').filter((e) => e !== 'NA').length > 2 ? 2 : 0, getItemLayout: (data, index) => ({ length: 100, offset: 100 * index, index }), contentContainerStyle: { alignItems: 'center' }, horizontal: true, renderItem: renderSizeItem, showsHorizontalScrollIndicator: false, keyExtractor: (item, index) => index.toString() })),
        !nobodyDetailsSavedBool && data.filter((c) => sizeDetails && sizeDetails[0] && sizeDetails[0].split(';').indexOf(c) < 0).length > 0 && react_1.default.createElement(react_native_1.View, { style: styles.sizeListOtherContainer },
            react_1.default.createElement(react_native_1.Text, { style: styles.sizeListLabel }, "Other available sizes"),
            react_1.default.createElement(react_native_1.FlatList, { data: data.filter((c) => sizeDetails && sizeDetails[0] && sizeDetails[0].split(';').indexOf(c) < 0), style: {
                    paddingTop: 32,
                    marginRight: 20,
                    flexGrow: 0,
                    flex: 1
                }, 
                // contentContainerStyle={{flex:1}}
                horizontal: true, renderItem: renderOtherSizeItem, showsHorizontalScrollIndicator: false, keyExtractor: (item, index) => index.toString() }),
            react_1.default.createElement(react_native_1.Text, { style: { fontSize: 12, color: SceneUtils_1.default.text_color_4, fontFamily: SceneUtils_1.default.whitney_book } }, "These sizes might not fit you."))));
    const getBottomText = (item, index) => {
        if (sizeDetails[sizeDetailsIndex] && sizeDetails[sizeDetailsIndex].includes(';')) {
            if (sizeDetails[sizeDetailsIndex].split(';')[0] === item) {
                return 'Tight fit';
            }
            else if (sizeDetails[sizeDetailsIndex].split(';')[1] === item) {
                return 'Slim fit';
            }
            else if (sizeDetails[sizeDetailsIndex].split(';')[2] === item) {
                return 'Regular fit';
            }
        }
        else if (sizeDetails[sizeDetailsIndex] === item) {
            return 'Slim Fit';
        }
    };
    const renderSizeItem = (item) => {
        return (react_1.default.createElement(react_native_1.View, { style: {
                marginLeft: item.index === 0 ? 0 : 8,
                height: 100
            } },
            react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => onSizeClicked(item.item), style: {
                    height: 40,
                    alignItems: 'center'
                } },
                react_1.default.createElement(react_native_1.Text, { style: data.indexOf(item.item) > -1
                        ? selectedSize === item.item
                            ? [styles.sizeText, { borderColor: SceneUtils_1.default.primary_color, color: SceneUtils_1.default.primary_color }]
                            : styles.sizeText
                        : [
                            styles.sizeText,
                            {
                                borderColor: SceneUtils_1.default.text_color_4,
                                color: SceneUtils_1.default.text_color_4,
                            },
                        ] }, item.item),
                (sizeDetails[sizeDetailsIndex] && (sizeDetails[sizeDetailsIndex].split(';')[1] === item.item || sizeDetails[sizeDetailsIndex].split(';')[2] === item.item)) ? react_1.default.createElement(react_native_1.View, { style: styles.recommededtxtContainer },
                    react_1.default.createElement(react_native_1.Text, { style: styles.recommededtxt }, "Recommended")) : react_1.default.createElement(react_native_1.View, { style: {
                        borderRadius: 2,
                        width: 56,
                        marginTop: 2
                    } },
                    react_1.default.createElement(react_native_1.Text, { style: styles.recommededtxt }, ".")),
                selectedSize === item.item && (react_1.default.createElement(react_native_1.Image, { style: {
                        position: "absolute",
                        top: 8,
                        height: 14,
                        width: 14,
                        borderRadius: 10,
                        left: 8
                    }, source: CheckSelected })),
                data.indexOf(item.item) < 0 && (react_1.default.createElement(react_native_1.View, { style: {
                        position: "absolute",
                        height: 1,
                        top: 30,
                        width: 40,
                        backgroundColor: SceneUtils_1.default.text_color_4,
                    } })),
                react_1.default.createElement(react_native_1.Text, { style: {
                        fontSize: 12,
                        color: SceneUtils_1.default.text_color,
                        marginTop: 8,
                        alignSelf: 'center',
                        fontFamily: SceneUtils_1.default.whitney_book
                    } }, getBottomText(item.item, item.index)))));
    };
    const renderOtherSizeItem = (item) => {
        return (react_1.default.createElement(react_native_1.View, { style: { height: 50 } },
            react_1.default.createElement(react_native_1.Text, { style: { marginLeft: item.index === 0 ? 0 : 16, fontSize: 16, color: SceneUtils_1.default.text_color_4 } }, item.item)));
    };
    return react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(react_native_1.View, { style: styles.container }, renderHeader()));
};
const styles = react_native_1.StyleSheet.create({
    container: {
        position: "absolute",
        bottom: 0,
        left: 0,
        right: 0,
        marginHorizontal: 16,
        // width: "96%",
        zIndex: 10
    },
    headerContainer: {
        flexDirection: "row",
        alignItems: "center",
        backgroundColor: "rgba(255,255,255,0.9)",
        borderTopLeftRadius: 5,
        borderTopRightRadius: 5
    },
    seperator: {
        height: 2,
        backgroundColor: "#d4d5d9",
        marginTop: -2,
        zIndex: 1,
    },
    sizeText: {
        fontSize: 16,
        height: 40,
        width: 40,
        color: SceneUtils_1.default.text_color,
        borderColor: SceneUtils_1.default.text_color,
        borderRadius: 20,
        borderWidth: 1,
        textAlign: "center",
        paddingTop: 10,
        marginTop: 10,
        fontFamily: SceneUtils_1.default.whitney_semibold
    },
    suggestionContainer: {
        backgroundColor: SceneUtils_1.default.text_color,
        width: '100%',
        borderRadius: 5,
        marginBottom: 9,
        padding: 15,
        paddingBottom: 21
    },
    suggestionText: {
        fontSize: 14,
        color: '#fff',
        lineHeight: 19,
        fontWeight: 'bold',
        marginBottom: 10
    },
    suggestionAction: {
        fontSize: 14,
        color: SceneUtils_1.default.primary_color,
        fontWeight: 'bold',
        marginTop: 7
    },
    modelSizeContainer: {
        flex: 1,
        flexDirection: 'row',
        marginTop: 5
    },
    sizeListTrialContainer: {
        flex: 0.55,
        marginLeft: 19,
        marginBottom: 30,
        marginTop: 14,
        paddingRight: 9
    },
    sizeListOtherContainer: {
        flex: 0.45,
        marginLeft: 19,
        marginBottom: 30,
        marginTop: 14
    },
    sizeListLabel: {
        fontSize: 14,
        color: SceneUtils_1.default.text_color,
        fontFamily: SceneUtils_1.default.whitney_book
    },
    recommededtxtContainer: {
        backgroundColor: SceneUtils_1.default.text_color,
        borderRadius: 2,
        width: 56,
        marginTop: 3
    },
    recommededtxt: {
        fontFamily: SceneUtils_1.default.whitney_semibold,
        fontSize: 8,
        color: 'white',
        height: 11,
        paddingHorizontal: 2,
    }
});
exports.default = BottomPopupSize;
//# sourceMappingURL=BottomPopupSize.js.map