"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const ImageButton_1 = __importDefault(require("../component/ImageButton"));
const axios_1 = __importDefault(require("axios"));
const Storage_1 = __importDefault(require("../utils/Storage"));
const StorageKeys_1 = __importDefault(require("../utils/StorageKeys"));
const BottomPopup_1 = __importDefault(require("../component/BottomPopup"));
const BottomPopupSize_1 = __importDefault(require("../component/BottomPopupSize"));
// import { FloatingAction } from "../component/floating";
const SceneUtils_1 = __importDefault(require("../utils/SceneUtils"));
const BodyUtils_1 = __importDefault(require("../utils/BodyUtils"));
const actions = [
    {
        text: "ADD TO BAG ",
        icon: require("../assets/images/shopping-bag.png"),
        name: "add_to_bag",
        position: 1,
    },
    {
        text: "ADD TO WISHLIST",
        icon: require("../assets/images/wishlist.png"),
        name: "add_to_wishlist",
        position: 2,
    },
];
let goToBagArr = [];
let prefixSKU = '';
let male = false;
class Scene extends react_1.default.Component {
    constructor(props) {
        super(props);
        this.componentDidMount = () => __awaiter(this, void 0, void 0, function* () {
            //Get device id
            male = false;
            if (this.ownProps && this.ownProps.styleid) {
                goToBagArr = [];
                if (this.ownProps.gender == "M") {
                    male = true;
                }
                this.ownProps.logEvent(this.ownProps.uuid, SceneUtils_1.default.VTR_LANDING_PAGE, `{styleID: ${this.ownProps.styleid}}`); //Myntra log
                //Wishlist check
                let _actions = this.state.actions;
                if (this.ownProps.isWishlisted) {
                    _actions[1].text = 'GO TO WISHLIST';
                    _actions[1].name = 'go_to_wishlist';
                }
                else {
                    _actions[1].text = 'ADD TO WISHLIST';
                    _actions[1].name = 'add_to_wishlist';
                }
                this.setState({ itm: this.ownProps.styleid, available_sizes: this.ownProps.available_sizes, is_male: male, action: _actions });
            }
            this.getThumbs();
            //First get the previous theme and set it in view and then call getTheme
            if (male) {
                Storage_1.default.retrieveData("themeRespMale", (value) => __awaiter(this, void 0, void 0, function* () {
                    if (value != null) {
                        const themeResp = JSON.parse(value);
                        yield this.setState({
                            themeImg: `data:image/png;base64,${themeResp.tImage}`,
                            wallBottomImg: `data:image/png;base64,${themeResp.bImage}`,
                            middleImg: `data:image/png;base64,${themeResp.mImage}`,
                        });
                    }
                    else {
                        this.getTheme();
                    }
                }));
            }
            else {
                Storage_1.default.retrieveData("themeResp", (value) => __awaiter(this, void 0, void 0, function* () {
                    if (value != null) {
                        const themeResp = JSON.parse(value);
                        yield this.setState({
                            themeImg: `data:image/png;base64,${themeResp.tImage}`,
                            wallBottomImg: `data:image/png;base64,${themeResp.bImage}`,
                            middleImg: `data:image/png;base64,${themeResp.mImage}`,
                        });
                    }
                    else {
                        this.getTheme();
                    }
                }));
            }
            this.callMethods();
            // this.focusListener = this.props.navigation.addListener('willFocus', () => {
            //   if(backFromEditBody) this.callMethods()
            // })
            if (male) {
                Storage_1.default.retrieveData("modelDimMale", (value) => {
                    if (value != null) {
                        const dim = JSON.parse(value);
                        Storage_1.default.retrieveData("modelPrevMale", (value1) => {
                            if (value1 != null) {
                                const model = JSON.parse(value1);
                                this.setState({ modelFront: `data:image/png;base64,${model.front}`, modelBack: `data:image/png;base64,${model.back}`,
                                    modelHeight: dim.height, modelMargin: dim.margin });
                            }
                        });
                    }
                });
            }
            else {
                Storage_1.default.retrieveData("modelDim", (value) => {
                    if (value != null) {
                        const dim = JSON.parse(value);
                        Storage_1.default.retrieveData("modelPrev", (value1) => {
                            if (value1 != null) {
                                const model = JSON.parse(value1);
                                this.setState({ modelFront: `data:image/png;base64,${model.front}`, modelBack: `data:image/png;base64,${model.back}`,
                                    modelHeight: dim.height, modelMargin: dim.margin });
                            }
                        });
                    }
                });
            }
            this.startAnimationBack(30);
            this.startAnimationFront(-30);
            this.animatedValue = new react_native_1.Animated.Value(0);
            this.frontInterpolate = this.animatedValue.interpolate({
                inputRange: [0, 180],
                outputRange: ["180deg", "360deg"],
            });
        });
        this.callMethods = () => {
            let bodyDetails = {};
            if (this.state.is_male ? this.state.is_male : male) {
                Storage_1.default.retrieveData("bodyDetailsMale", (value) => __awaiter(this, void 0, void 0, function* () {
                    if (value != null) {
                        bodyDetails = JSON.parse(value);
                        yield this.setState({ bodyDetailsSavedMale: bodyDetails === null || bodyDetails === void 0 ? void 0 : bodyDetails.bodyDetailsSavedMale, sz_male: bodyDetails === null || bodyDetails === void 0 ? void 0 : bodyDetails.sz_male, sizeDetailsIndex: 1 });
                    }
                    this.getVData();
                }));
                Storage_1.default.retrieveData("firstLaunchMale", (value) => {
                    if (value != null) {
                        this.setState({ firstLaunchMale: false, showButtons: true });
                    }
                    else {
                        this.setState({ firstLaunchMale: true, showButtons: true });
                    }
                });
                SceneUtils_1.default.callLogEventTNB(this.ownProps.uuid, SceneUtils_1.default.VTR_SCREEN_LOAD, `{styleID: ${this.ownProps.styleid}, sessionID: ${this.ownProps.sessionid}, deviceID: ${this.ownProps.deviceid}, recommendation: ${!(bodyDetails === null || bodyDetails === void 0 ? void 0 : bodyDetails.bodyDetailsSavedMale) ? 'Non Personalised' : 'Personalised'}, recommended_sizes: ${''}}`); //TNB log
            }
            else {
                Storage_1.default.retrieveData("bodyDetails", (value) => __awaiter(this, void 0, void 0, function* () {
                    if (value != null) {
                        bodyDetails = JSON.parse(value);
                        // console.log('bodyDetails storage called female ', bodyDetails)
                        yield this.setState({ bodyDetailsSaved: bodyDetails === null || bodyDetails === void 0 ? void 0 : bodyDetails.bodyDetailsSaved, sz: bodyDetails === null || bodyDetails === void 0 ? void 0 : bodyDetails.sz, sizeDetailsIndex: 1 });
                    }
                    this.getVData();
                    this.getTheme(); //In case we have trasitioned from celeb
                }));
                Storage_1.default.retrieveData("firstLaunch", (value) => {
                    if (value != null) {
                        this.setState({ firstLaunch: false, showButtons: true });
                    }
                    else {
                        this.setState({ firstLaunch: true, showButtons: true });
                    }
                });
                SceneUtils_1.default.callLogEventTNB(this.ownProps.uuid, SceneUtils_1.default.VTR_SCREEN_LOAD, `{styleID: ${this.ownProps.styleid}, sessionID: ${this.ownProps.sessionid}, deviceID: ${this.ownProps.deviceid}, recommendation: ${!(bodyDetails === null || bodyDetails === void 0 ? void 0 : bodyDetails.bodyDetailsSaved) ? 'Non Personalised' : 'Personalised'}, recommended_sizes: ${''}}`); //TNB log
            }
        };
        // and don't forget to remove the listener
        this.componentWillUnmount = () => {
            // this.focusListener.remove()
        };
        this.getThumbs = () => {
            axios_1.default.get(`${SceneUtils_1.default.BASE_URL}/api/getthumbs`)
                .then((response) => {
                this.setState({ thumbnails: response.data });
            }).catch((error) => {
                console.log(error);
            });
        };
        this.getLipstick = (skinTone) => {
            // console.log('getLipstick ', skinTone)
            axios_1.default.get(`${SceneUtils_1.default.BASE_URL}/api/getlipstick/${skinTone}`).then((response) => {
                // console.log('getLipstick response ', response.data)
                this.setState({ lipstickArr: response.data }, () => this.callVData(prefixSKU));
            }).catch((error) => {
                console.log(error);
            });
        };
        this.getVData = () => {
            prefixSKU = '';
            if (this.state.sizeDetails && this.state.sizeDetails.length > 0 && this.state.sizeDetails[this.state.sizeDetailsIndex] && this.state.sizeDetails[this.state.sizeDetailsIndex].includes(';')) {
                let sizes = this.state.sizeDetails[this.state.sizeDetailsIndex].split(';');
                if (sizes.indexOf(this.state.selectedSize) === 0) {
                    prefixSKU = '-minus';
                }
                else if (sizes.indexOf(this.state.selectedSize) === 2) {
                    prefixSKU = '-plus';
                }
            }
            if (this.state.bodyDetailsSaved) {
                Storage_1.default.retrieveData(StorageKeys_1.default.GETVDATA_BODY, (value) => __awaiter(this, void 0, void 0, function* () {
                    let _skinTone = this.state.skinTone;
                    if (value != null) {
                        const body = JSON.parse(value);
                        let _selectedPopupData = this.state.selectedPopupData;
                        _selectedPopupData.skinIndex = body.P2 === '' ? '3' : body.P2,
                            _selectedPopupData.hairIndex = body.P3,
                            _selectedPopupData.lipsIndex = body.P4,
                            yield this.setState({
                                selectedPopupData: _selectedPopupData,
                                SkinTone: body.P2 === '' ? '3' : body.P2,
                                Hair: body.P3,
                                lipstick: body.P4,
                            }, () => _skinTone = body.P2 === '' ? '3' : body.P2);
                    }
                    if (_skinTone)
                        this.getLipstick(_skinTone);
                    else
                        this.callVData(prefixSKU);
                }));
            }
            else if (this.state.is_male) {
                Storage_1.default.retrieveData(StorageKeys_1.default.GETVDATA_BODY_MALE, (value) => __awaiter(this, void 0, void 0, function* () {
                    if (value != null) {
                        const body = JSON.parse(value);
                        let _selectedPopupData = this.state.selectedPopupData;
                        _selectedPopupData.hairIndexMale = body.P3,
                            _selectedPopupData.skinIndexMale = body.P2 === '' ? '3' : body.P2,
                            yield this.setState({
                                selectedPopupData: _selectedPopupData,
                                HairMale: body.P3,
                                SkinToneMale: body.P2 === '' ? '3' : body.P2,
                            });
                    }
                    this.callVData(prefixSKU);
                }));
            }
            else {
                Storage_1.default.retrieveData(StorageKeys_1.default.GETVDATA_BODY_CELEB, (value) => __awaiter(this, void 0, void 0, function* () {
                    if (value != null) {
                        const body = JSON.parse(value);
                        let _selectedPopupData = this.state.selectedPopupData;
                        _selectedPopupData.hairIndex = body.P6,
                            _selectedPopupData.lipsIndex = body.P3,
                            yield this.setState({
                                selectedPopupData: _selectedPopupData,
                                HairCeleb: body.P6,
                                lipstickCeleb: body.P3,
                            });
                    }
                    this.callVData(prefixSKU);
                }));
            }
        };
        this.callVData = (prefixSKU) => {
            const { itm, SkinTone, SkinToneMale, Hair, HairMale, HairCeleb, lipstick, lipstickCeleb, fb, ilst, sz, sz_male, rz, is_male, sizeDetailsIndex, lipstickArr } = this.state;
            let _lipstick = lipstick;
            if (lipstickArr.lipstick && Array.isArray(lipstickArr.lipstick)) {
                const _lipstickObj = lipstickArr.lipstick.find((c) => c.id == lipstick);
                if (!_lipstickObj) {
                    _lipstick = lipstickArr.lipstick[0].id;
                    let _selectedPopupData = this.state.selectedPopupData;
                    _selectedPopupData.lipsIndex = _lipstick,
                        this.setState({
                            selectedPopupData: _selectedPopupData
                        });
                }
            }
            let body = {
                P1: `${itm}${prefixSKU}`,
                P2: (this.state.bodyDetailsSaved || is_male) ? (is_male ? SkinToneMale : SkinTone) : '',
                P3: (this.state.bodyDetailsSaved || is_male) ? (is_male ? HairMale : Hair) : lipstickCeleb,
                P4: (this.state.bodyDetailsSaved || is_male) ? (is_male ? '' : _lipstick) : 0,
                P5: (this.state.bodyDetailsSaved || is_male) ? '' : `${itm}${prefixSKU}`,
                P6: (this.state.bodyDetailsSaved || is_male) ? `${itm}${prefixSKU}` : HairCeleb,
                P7: is_male ? sz_male : sz,
                P8: rz,
                P11: this.state.is_male ? (this.state.firstLaunchMale ? 0 : 1) : (this.state.firstLaunch ? 0 : 1),
                P12: 0,
                P13: 0
            };
            this.ownProps.logEvent(this.ownProps.uuid, SceneUtils_1.default.GETVDATA_CALLED, `{request: ${JSON.stringify(body)}}`); //Myntra log
            const url = `${SceneUtils_1.default.BASE_URL}/${!this.state.bodyDetailsSaved && !is_male ? "api/getcelebvirtual/getvirtualdata" : "api/virtual/getVirtualData"}`;
            console.log(`getVData request : `, body);
            if (this.state.bodyDetailsSaved) {
                Storage_1.default.saveItem(StorageKeys_1.default.GETVDATA_BODY, JSON.stringify(body));
            }
            else if (this.state.is_male) {
                Storage_1.default.saveItem(StorageKeys_1.default.GETVDATA_BODY_MALE, JSON.stringify(body));
            }
            else {
                Storage_1.default.saveItem(StorageKeys_1.default.GETVDATA_BODY_CELEB, JSON.stringify(body));
            }
            axios_1.default
                .post(url, body, {
                headers: {
                    AuthID: "123",
                    UID: this.ownProps.uuid
                },
            })
                .then((response) => {
                //alert(Date.now()-callVDataStart)
                console.log(`getVData response: `, response.data);
                let itemsThumb = response.data.thumb;
                let item1Thumb, item2Thumb = "";
                if (itemsThumb.length > 0)
                    item1Thumb = itemsThumb[0];
                if (itemsThumb.length == 2)
                    item2Thumb = itemsThumb[1];
                var model = {};
                model.front = response.data.fImage;
                model.back = response.data.bImage;
                if (is_male) {
                    Storage_1.default.saveItem("modelPrevMale", JSON.stringify(model));
                }
                else {
                    Storage_1.default.saveItem("modelPrev", JSON.stringify(model));
                }
                var dim = {};
                dim.height = response.data.modelHeight;
                dim.margin = response.data.modelMargin;
                if (is_male) {
                    Storage_1.default.saveItem("modelDimMale", JSON.stringify(dim));
                }
                else {
                    Storage_1.default.saveItem("modelDim", JSON.stringify(dim));
                }
                //Save celebrity size data in bodyDetails
                if (!this.state.is_male && !this.state.bodyDetailsSaved && response.data.modelSize && response.data.modelSize !== '') {
                    const dimArr = response.data.modelSize.split(',');
                    Storage_1.default.saveItem("bodyDetails", JSON.stringify({
                        heightFeet: dimArr[0].split('.')[0],
                        heightInch: dimArr[0].split('.')[1],
                        waist: dimArr[4],
                        hip: dimArr[5],
                        weight: dimArr[1],
                        bandSize: dimArr[2],
                        cupSize: dimArr[3],
                        selectedHeaderIndex: dimArr[6],
                        bodyShapeIndex: 0,
                        bodyDetailsSaved: this.state.bodyDetailsSaved
                    }));
                }
                else if (this.state.is_male && !this.state.bodyDetailsSavedMale && response.data.modelSize && response.data.modelSize !== '') {
                    const dimArr = response.data.modelSize.split(',');
                    Storage_1.default.saveItem("bodyDetailsMale", JSON.stringify({
                        heightFeetMale: dimArr[0].split('.')[0],
                        heightInchMale: dimArr[0].split('.')[1],
                        waistMale: dimArr[4],
                        hipMale: dimArr[5],
                        weightMale: dimArr[1],
                        chestSize: dimArr[2],
                        bodyDetailsSavedMale: true
                    }));
                }
                let _sizeDetailsIndex = 0;
                if (response.data.itemList) { //Get the index of selected item from Myntra whether top or bottom
                    if (Array.isArray(response.data.itemList)) {
                        _sizeDetailsIndex = response.data.itemList.indexOf(this.state.itm);
                    }
                }
                //Get the index of sizeDetails selected
                let sizeDetailsDefaultIndex = 1;
                if (body.P1 && body.P1.includes('minus')) {
                    sizeDetailsDefaultIndex = 0;
                }
                else if (body.P1 && body.P1.includes('plus')) {
                    sizeDetailsDefaultIndex = 2;
                }
                //By default from response
                let _selectedSize = (response.data.sizeDetails[_sizeDetailsIndex] && response.data.sizeDetails[_sizeDetailsIndex].includes(';')) ? response.data.sizeDetails[_sizeDetailsIndex] && response.data.sizeDetails[_sizeDetailsIndex].split(';')[sizeDetailsDefaultIndex] : response.data.sizeDetails[_sizeDetailsIndex]; //Middle one is recommended one
                if (_selectedSize === 'NA')
                    _selectedSize = response.data.sizeDetails[_sizeDetailsIndex].split(';')[sizeDetailsDefaultIndex + 1];
                let _actions = this.state.actions;
                if (goToBagArr.indexOf(_selectedSize) === -1) {
                    _actions[0].text = 'ADD TO BAG';
                    _actions[0].name = 'add_to_bag';
                }
                else {
                    _actions[0].text = 'GO TO BAG';
                    _actions[0].name = 'go_to_bag';
                }
                this.setState({
                    modelFront: `data:image/png;base64,${response.data.fImage}`,
                    shadowImg: `data:image/png;base64,${response.data.sImage}`,
                    modelBack: `data:image/png;base64,${response.data.bImage}`,
                    itemThumb1: `data:image/png;base64,${item1Thumb}`,
                    itemThumb2: `data:image/png;base64,${item2Thumb}`,
                    ilst: response.data.itemList,
                    sizeDetails: response.data.sizeDetails,
                    sizeDifferences: response.data.sizeDifference,
                    itemTypeList: response.data.itemTypeList,
                    itemCat: response.data.itemCat,
                    itemTypes: response.data.itemTypes,
                    itemAllSizes: response.data.itemAllSizes,
                    modelSize: response.data.modelSize,
                    sizeDetailsIndex: _sizeDetailsIndex,
                    selectedSize: _selectedSize,
                    actions: _actions,
                    modelHeight: response.data.modelHeight,
                    modelMargin: response.data.modelMargin
                });
            })
                .catch((error) => {
                console.log(error);
            });
        };
        this.getTheme = () => {
            if (this.state.is_male) {
                Storage_1.default.retrieveData(StorageKeys_1.default.THEME_KEY_MALE, (value) => __awaiter(this, void 0, void 0, function* () {
                    let _selectedPopupData = this.state.selectedPopupData;
                    if (value != null) {
                        _selectedPopupData.backDropIndexMale = value;
                        yield this.setState({ selectedPopupData: _selectedPopupData });
                    }
                    this.callTheme();
                }));
            }
            else {
                this.state.bodyDetailsSaved ? Storage_1.default.retrieveData(StorageKeys_1.default.THEME_KEY, (value) => __awaiter(this, void 0, void 0, function* () {
                    let _selectedPopupData = this.state.selectedPopupData;
                    if (value != null) {
                        _selectedPopupData.backDropIndex = value;
                    }
                    else {
                        _selectedPopupData.backDropIndex = "4";
                    }
                    this.callTheme();
                })) : Storage_1.default.retrieveData(StorageKeys_1.default.THEME_KEY_CELEB, (value) => __awaiter(this, void 0, void 0, function* () {
                    let _selectedPopupData = this.state.selectedPopupData;
                    if (value != null) {
                        _selectedPopupData.backDropIndex = value;
                    }
                    else {
                        _selectedPopupData.backDropIndex = "11";
                    }
                    yield this.setState({ selectedPopupData: _selectedPopupData });
                    this.callTheme();
                }));
            }
        };
        this.callTheme = () => {
            // console.log('Scene callTheme >>>> ',Date.now())
            const themeID = this.state.is_male ? this.state.selectedPopupData.backDropIndexMale : this.state.selectedPopupData.backDropIndex;
            axios_1.default
                .get(`https://d01.tryndbuy.com/api/GetTI/get?AuthID=123&id=${themeID}`)
                .then((response) => {
                // console.log('Scene callTheme Response >>>> ',Date.now())
                Storage_1.default.saveItem(this.state.is_male ? "themeRespMale" : "themeResp", JSON.stringify(response.data));
                this.setState({
                    themeImg: `data:image/png;base64,${response.data.tImage}`,
                    wallBottomImg: `data:image/png;base64,${response.data.bImage}`,
                    middleImg: `data:image/png;base64,${response.data.mImage}`,
                });
            })
                .catch((error) => {
                console.log(`Theme error: ${error}`);
            });
            this.ownProps.logEvent(this.ownProps.uuid, SceneUtils_1.default.CHANGE_THEME, `{themeId: ${themeID}}`); //Myntra log
        };
        this.editBody = () => {
            console.log("🚀 ~ file: Scene.tsx ~ line 643 ~ Scene ~ this.props", this.props);
            this.props.navigation.navigate("BodyDetails", {
                ownProps: this.ownProps,
                is_male: this.state.is_male,
                onGoBack: () => {
                    this.callMethods();
                }
            });
            this.state.is_male ? Storage_1.default.saveItem('firstLaunchMale', "0") : Storage_1.default.saveItem('firstLaunch', "0");
            this.setState({ addToBagWarningBool: false });
            this.ownProps.logEvent(this.ownProps.uuid, SceneUtils_1.default.EDIT_BODY_WIDGET_CLICK, '');
            SceneUtils_1.default.callLogEventTNB(this.ownProps.uuid, SceneUtils_1.default.PERSONALISE_CLICKED, `{styleID: ${this.ownProps.styleid}, sessionID: ${this.ownProps.sessionid}, deviceID: ${this.ownProps.deviceid}}`); //TNB log
        };
        this.onImageButtonClicked = (itemClicked) => {
            if (itemClicked === 'customize') {
                this.ownProps.logEvent(this.ownProps.uuid, SceneUtils_1.default.CUSTOMIZE_WIDGET_CLICK, '');
                SceneUtils_1.default.callLogEventTNB(this.ownProps.uuid, SceneUtils_1.default.CUSTOMISE_CLICKED, `{styleID: ${this.ownProps.styleid}, sessionID: ${this.ownProps.sessionid}, deviceID: ${this.ownProps.deviceid}}`); //TNB log
            }
            else {
                this.ownProps.logEvent(this.ownProps.uuid, SceneUtils_1.default.SIZE_WIDGET_CLICK, '');
                SceneUtils_1.default.callLogEventTNB(this.ownProps.uuid, SceneUtils_1.default.SIZE_CLICKED, `{styleID: ${this.ownProps.styleid}, sessionID: ${this.ownProps.sessionid}, deviceID: ${this.ownProps.deviceid}, recommended_sizes_count: ${0}, recommended_available_sizes_count: ${0}, non_recommded_sizes_count: ${0}, non_recommended_available_sizes_count: ${0}, recommended_sizes: ${''}}`); //TNB log
            }
            this.state.is_male ? Storage_1.default.saveItem('firstLaunchMale', "0") : Storage_1.default.saveItem('firstLaunch', "0");
            if (this.state.sizeDetails && this.state.sizeDetails[0] && this.state.sizeDetails[0].split(';').length > 0) {
                this.state.is_male ? this.setState({
                    showBottomPopup: itemClicked === "customize" ? true : false,
                    showBottomPopupSize: itemClicked === "customize" ? false : true,
                    showButtons: false,
                    firstLaunchMale: false,
                    addToBagWarningBool: false
                }) :
                    this.setState({
                        showBottomPopup: itemClicked === "customize" ? true : false,
                        showBottomPopupSize: itemClicked === "customize" ? false : true,
                        showButtons: false,
                        firstLaunch: false,
                        addToBagWarningBool: false
                    });
            }
            else {
                //Show alert for not fit
                this.setState({ alertDefault: true, message: `These sizes will not fit you.` });
                setTimeout(() => {
                    this.setState({ alertDefault: false });
                }, 2000);
            }
        };
        this.startAnimationBack = (value) => {
            react_native_1.Animated.timing(this.state.animationBack, {
                toValue: value,
                duration: 8000,
                useNativeDriver: true,
            }).start((o) => {
                if (o.finished) {
                    this.setState({ animationBack: new react_native_1.Animated.Value(value) });
                    if (value == 30)
                        this.startAnimationBack(0);
                    else
                        this.startAnimationBack(30);
                }
            });
        };
        this.startAnimationFront = (value) => {
            react_native_1.Animated.timing(this.state.animationFront, {
                toValue: value,
                duration: 8000,
                useNativeDriver: true,
            }).start((o) => {
                this.setState({ animationFront: new react_native_1.Animated.Value(value) });
                if (o.finished) {
                    if (this.state.animationFront == -30)
                        this.startAnimationFront(0);
                    else
                        this.startAnimationFront(-30);
                }
            });
        };
        this.selectedOption = (type, itemid) => {
            // console.log('Selected Option ', type+' '+itemid)
            SceneUtils_1.default.callLogEventTNB(this.ownProps.uuid, SceneUtils_1.default.CUSTOMISE_TAB_ITEMS_CLICK, `{styleID: ${this.ownProps.styleid}, sessionID: ${this.ownProps.sessionid}, deviceID: ${this.ownProps.deviceid}, customize_tab_name: ${type} customize_tab_item: ${itemid}}`); //TNB log
            const { itm, SkinTone, SkinToneMale, Hair, HairMale, HairCeleb, lipstick, lipstickCeleb, sz, sz_male, rz, is_male, } = this.state;
            //Save in async for theme
            if (type === "backDropIndex") {
                this.state.bodyDetailsSaved ? Storage_1.default.saveItem(StorageKeys_1.default.THEME_KEY, `${itemid}`, () => {
                    this.getTheme();
                }) : Storage_1.default.saveItem(StorageKeys_1.default.THEME_KEY_CELEB, `${itemid}`, () => {
                    this.getTheme();
                });
            }
            else if (type === "backDropIndexMale") {
                Storage_1.default.saveItem(StorageKeys_1.default.THEME_KEY_MALE, `${itemid}`, () => {
                    this.getTheme();
                });
            }
            else {
                //For others save in a JSON object for body of getVData
                var body = {
                    P1: `${itm}${prefixSKU}`,
                    P2: (this.state.bodyDetailsSaved || is_male) ? (is_male ? SkinToneMale : SkinTone) : '',
                    P3: (this.state.bodyDetailsSaved || is_male) ? (is_male ? HairMale : Hair) : lipstickCeleb,
                    P4: (this.state.bodyDetailsSaved || is_male) ? lipstick : 0,
                    P5: (this.state.bodyDetailsSaved || is_male) ? '' : `${itm}${prefixSKU}`,
                    P6: (this.state.bodyDetailsSaved || is_male) ? `${itm}${prefixSKU}` : HairCeleb,
                    P7: is_male ? sz_male : sz,
                    P8: rz,
                    P11: this.state.is_male ? (this.state.firstLaunchMale ? 0 : 1) : (this.state.firstLaunch ? 0 : 1),
                    P12: 0,
                    P13: 0
                };
                if (this.state.bodyDetailsSaved) {
                    Storage_1.default.retrieveData(StorageKeys_1.default.GETVDATA_BODY, (value) => {
                        if (value != null)
                            body = JSON.parse(value);
                    });
                }
                else if (this.state.is_male) {
                    Storage_1.default.retrieveData(StorageKeys_1.default.GETVDATA_BODY_MALE, (value) => {
                        if (value != null)
                            body = JSON.parse(value);
                    });
                }
                else {
                    Storage_1.default.retrieveData(StorageKeys_1.default.GETVDATA_BODY_CELEB, (value) => {
                        if (value != null)
                            body = JSON.parse(value);
                    });
                }
                switch (type) {
                    case "hairIndex":
                        if (this.state.bodyDetailsSaved)
                            body.P3 = itemid + "";
                        else
                            body.P6 = itemid + "";
                        this.state.bodyDetailsSaved ? this.setState({ Hair: itemid, [type]: itemid }) : this.setState({ HairCeleb: itemid, [type]: itemid });
                        break;
                    case "hairIndexMale":
                        body.P3 = itemid + "";
                        this.setState({ HairMale: itemid, [type]: itemid });
                        break;
                    case "skinIndex":
                        if (this.state.bodyDetailsSaved)
                            body.P2 = itemid + "";
                        this.setState({ SkinTone: itemid, [type]: itemid }, () => this.getLipstick(itemid));
                        break;
                    case "skinIndexMale":
                        body.P2 = itemid + "";
                        this.setState({ SkinToneMale: itemid, [type]: itemid });
                        break;
                    case "lipsIndex":
                        if (this.state.bodyDetailsSaved || is_male)
                            body.P4 = itemid + "";
                        else
                            body.P3 = itemid + "";
                        this.state.bodyDetailsSaved ? this.setState({ lipstick: itemid, [type]: itemid }) : this.setState({ lipstickCeleb: itemid, [type]: itemid });
                        break;
                }
                if (this.state.bodyDetailsSaved) {
                    Storage_1.default.saveItem(StorageKeys_1.default.GETVDATA_BODY, JSON.stringify(body), () => {
                        if (type !== "headerIndex")
                            this.getVData();
                    });
                }
                else if (this.state.is_male) {
                    Storage_1.default.saveItem(StorageKeys_1.default.GETVDATA_BODY_MALE, JSON.stringify(body), () => {
                        if (type !== "headerIndex")
                            this.getVData();
                    });
                }
                else {
                    Storage_1.default.saveItem(StorageKeys_1.default.GETVDATA_BODY_CELEB, JSON.stringify(body), () => {
                        if (type !== "headerIndex")
                            this.getVData();
                    });
                }
                this.ownProps.logEvent(this.ownProps.uuid, SceneUtils_1.default.CUSTOMIZATION_CHANGE, `{type: ${type}, itemID: ${itemid}}`); //Myntra log
            }
        };
        this.onHeaderItemClick = (type, id) => {
            SceneUtils_1.default.callLogEventTNB(this.ownProps.uuid, SceneUtils_1.default.CUSTOMISE_TABS_CLICK, `{styleID: ${this.ownProps.styleid}, sessionID: ${this.ownProps.sessionid}, deviceID: ${this.ownProps.deviceid}, customize_tab_name: ${type}}`); //TNB log
            let _selectedPopupData = Object.assign({}, this.state.selectedPopupData);
            _selectedPopupData[type] = id;
            this.setState({ selectedPopupData: _selectedPopupData });
            this.selectedOption(type, id);
        };
        this.onSizeClicked = (size) => {
            this.ownProps.logEvent(this.ownProps.uuid, SceneUtils_1.default.SIZE_TRIED, `{size: ${size}}`); //Myntra log
            SceneUtils_1.default.callLogEventTNB(this.ownProps.uuid, SceneUtils_1.default.SIZE_ITEM_CLICK, `{styleID: ${this.ownProps.styleid}, sessionID: ${this.ownProps.sessionid}, deviceID: ${this.ownProps.deviceid}, size: ${size}}`); //TNB log
            let _actions = this.state.actions;
            if (goToBagArr.indexOf(size) === -1) {
                _actions[0].text = 'ADD TO BAG';
                _actions[0].name = 'add_to_bag';
            }
            else {
                _actions[0].text = 'GO TO BAG';
                _actions[0].name = 'go_to_bag';
            }
            this.setState({ selectedSize: size, actions: _actions }, () => {
                this.getVData();
            });
        };
        this.showSizeDetails = () => {
            this.props.navigation.navigate('SizeDetails');
        };
        this.dismissPopup = () => {
            this.state.is_male ? Storage_1.default.saveItem('firstLaunchMale', "0") : Storage_1.default.saveItem('firstLaunch', "0");
            this.state.is_male ? this.setState({ firstLaunchMale: false }) : this.setState({ firstLaunch: false });
        };
        this.renderPopup = () => {
            let celebModelHeightFeet = 5, celebModelHeightInch = 11, celebModelWeight = 64, bodyShape = '';
            const { modelSize, selectedSize } = this.state;
            if (modelSize && modelSize !== '') {
                const dimArr = modelSize.split(',');
                celebModelHeightFeet = dimArr[0].split('.')[0];
                celebModelHeightInch = dimArr[0].split('.')[1];
                celebModelWeight = dimArr[1];
                if (!this.state.is_male)
                    bodyShape = BodyUtils_1.default.body_shape.find(c => c.id == dimArr[6]).name;
            }
            return (react_1.default.createElement(react_1.default.Fragment, null, react_1.default.createElement(react_native_1.View, { style: styles.suggestionContainer },
                react_1.default.createElement(react_native_1.Text, { style: styles.suggestionText }, "Personalise this model to your own preferences."),
                react_1.default.createElement(react_native_1.View, { style: styles.modelSizeContainer },
                    this.renderModelSize('Model wearing', ` Size ${selectedSize}`),
                    this.renderModelSize('Height', ` ${celebModelHeightFeet}' ${celebModelHeightInch}"`)),
                react_1.default.createElement(react_native_1.View, { style: styles.modelSizeContainer },
                    this.renderModelSize('Weight', ` ${celebModelWeight} kg`),
                    this.renderModelSize('Body shape', ` ${bodyShape}`)),
                react_1.default.createElement(react_native_1.View, { style: { flexDirection: 'row', marginTop: 12 } },
                    react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => this.editBody() },
                        react_1.default.createElement(react_native_1.Text, { style: styles.suggestionAction }, "Personalise here")),
                    react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => this.dismissPopup() },
                        react_1.default.createElement(react_native_1.Text, { style: [styles.suggestionAction, { marginLeft: 16 }] }, "Dismiss"))))));
        };
        this.renderPopupMale = () => {
            let celebModelHeightFeet = 5, celebModelHeightInch = 11, celebModelWeight = 64, bodyShape = '';
            const { modelSize, selectedSize } = this.state;
            if (modelSize && modelSize !== '') {
                const dimArr = modelSize.split(',');
                celebModelHeightFeet = dimArr[0].split('.')[0];
                celebModelHeightInch = dimArr[0].split('.')[1];
                celebModelWeight = dimArr[1];
                // bodyShape = BodyUtils.body_shape.find(c => c.id == dimArr[6]).name
            }
            return (react_1.default.createElement(react_1.default.Fragment, null, react_1.default.createElement(react_native_1.View, { style: styles.suggestionContainer },
                react_1.default.createElement(react_native_1.Text, { style: styles.suggestionText }, "Personalise this model to your own preferences."),
                react_1.default.createElement(react_native_1.View, { style: styles.modelSizeContainer },
                    this.renderModelSize('Model wearing', ` Size ${selectedSize}`),
                    this.renderModelSize('Height', ` ${celebModelHeightFeet}' ${celebModelHeightInch}"`)),
                react_1.default.createElement(react_native_1.View, { style: styles.modelSizeContainer }, this.renderModelSize('Weight', ` ${celebModelWeight} kg`)),
                react_1.default.createElement(react_native_1.View, { style: { flexDirection: 'row', marginTop: 12 } },
                    react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => this.editBody() },
                        react_1.default.createElement(react_native_1.Text, { style: styles.suggestionAction }, "Personalise here")),
                    react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => this.dismissPopup() },
                        react_1.default.createElement(react_native_1.Text, { style: [styles.suggestionAction, { marginLeft: 16 }] }, "Dismiss"))))));
        };
        this.renderAddToBagWarning = () => {
            const { selectedSize } = this.state;
            return (react_1.default.createElement(react_1.default.Fragment, null, react_1.default.createElement(react_native_1.View, { style: [styles.suggestionContainer, { paddingTop: 10, paddingBottom: 16 }] },
                react_1.default.createElement(react_native_1.View, { style: { flexDirection: 'row', justifyContent: 'space-between' } },
                    react_1.default.createElement(react_native_1.Text, { style: [styles.suggestionText, { marginBottom: 0 }] }, `Size ${selectedSize} added to Bag`),
                    react_1.default.createElement(ImageButton_1.default, { imagepath: require("../assets/images/cancel.png"), width: 12, height: 12, marginTop: 8, onPress: () => this.setState({ addToBagWarningBool: false }) })),
                react_1.default.createElement(react_native_1.View, { style: [styles.modelSizeContainer, { marginTop: 5 }] },
                    react_1.default.createElement(react_native_1.Text, { style: { color: '#fff', fontSize: 14, fontFamily: SceneUtils_1.default.whitney_book, paddingRight: 20 } }, `Size ${selectedSize} is recommended based on default model. Personalise it for better recommendations`)),
                react_1.default.createElement(react_native_1.View, { style: { flexDirection: 'row', marginTop: 5 } },
                    react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => this.editBody() },
                        react_1.default.createElement(react_native_1.Text, { style: styles.suggestionAction }, "Personalise here")),
                    react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => this.ownProps.goToBag() },
                        react_1.default.createElement(react_native_1.Text, { style: [styles.suggestionAction, { marginLeft: 16 }] }, "Go to bag"))))));
        };
        this.renderAddToBagSizeError = () => {
            const { selectedSize } = this.state;
            return (react_1.default.createElement(react_1.default.Fragment, null, react_1.default.createElement(react_native_1.View, { style: [styles.suggestionContainer, { paddingTop: 10, paddingBottom: 16 }] },
                react_1.default.createElement(react_native_1.View, { style: { flexDirection: 'row', justifyContent: 'space-between' } },
                    react_1.default.createElement(react_native_1.Text, { style: [styles.suggestionText, { marginBottom: 0 }] }, `Uh-oh! Couldn’t add Size ${selectedSize} to bag`),
                    react_1.default.createElement(ImageButton_1.default, { imagepath: require("../assets/images/cancel.png"), width: 12, height: 12, marginTop: 8, onPress: () => this.setState({ addToBagSizeErrorBool: false }) })),
                react_1.default.createElement(react_native_1.View, { style: [styles.modelSizeContainer, { marginTop: 5 }] },
                    react_1.default.createElement(react_native_1.Text, { style: { color: '#fff', fontSize: 14, fontFamily: SceneUtils_1.default.whitney_book, paddingRight: 20 } }, `Size ${selectedSize} is out of stock`)),
                react_1.default.createElement(react_native_1.View, { style: { flexDirection: 'row', marginTop: 5 } },
                    react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => this.setState({ addToBagSizeErrorBool: false, showBottomPopupSize: true, showButtons: false, addToBagWarningBool: false }) },
                        react_1.default.createElement(react_native_1.Text, { style: styles.suggestionAction }, "Try another size")),
                    !this.ownProps.isWishlisted && react_1.default.createElement(react_native_1.TouchableOpacity, { onPress: () => this.ownProps.addToWishList() },
                        react_1.default.createElement(react_native_1.Text, { style: [styles.suggestionAction, { marginLeft: 16 }] }, "Add to wishlist"))))));
        };
        this.renderAlert = () => {
            return (react_1.default.createElement(react_1.default.Fragment, null, react_1.default.createElement(react_native_1.View, { style: [styles.suggestionContainer, { paddingTop: 10, paddingBottom: 16 }] },
                react_1.default.createElement(react_native_1.Text, { style: [styles.suggestionText, { marginBottom: 0 }] }, this.state.message))));
        };
        this.renderModelSize = (label, text) => (react_1.default.createElement(react_native_1.View, { style: { flexDirection: 'row', flex: 0.5 } },
            react_1.default.createElement(react_native_1.Text, { style: { color: SceneUtils_1.default.text_color_4, fontSize: 14, fontFamily: SceneUtils_1.default.whitney_book } },
                label,
                ":"),
            react_1.default.createElement(react_native_1.Text, { style: { color: '#fff', fontSize: 14, fontFamily: SceneUtils_1.default.whitney_book } }, text)));
        this.ownProps =
            {
                uuid: '123',
                styleid: '10703194',
                gender: 'F',
                available_sizes: ['XXS', 'XS', 'S'],
                closePopup: () => { },
                addToBagDisabled: false,
                addToBag: (obj) => { },
                addToWishList: (obj) => { },
                goToBag: () => { },
                available_in_bag: true,
                logEvent: (uuid, eventName, eventData) => { }
            };
        //props.navigation && props.navigation.getParam('ownProps', {})
        this.state = {
            showpopup: false,
            posY: "41%",
            popupdata: [],
            itm: "",
            SkinTone: "3",
            SkinToneMale: "3",
            Hair: "1",
            HairMale: "1",
            HairCeleb: "1",
            lipstick: "4",
            lipstickCeleb: "4",
            fb: 0,
            ilst: [],
            sz: "",
            sz_male: "",
            rz: "",
            selectedType: "",
            displayFront: true,
            animationBack: new react_native_1.Animated.Value(0),
            animationFront: new react_native_1.Animated.Value(0),
            themeImg: "",
            wallBottomImg: "",
            middleImg: "",
            modelFront: "",
            modelBack: "",
            shadowImg: "",
            rowItems: 5,
            popupWidth: "",
            imgWidth: "",
            itemThumb1: "",
            itemThumb2: "",
            is_male: false,
            sizeDetails: [],
            sizeDifferences: [],
            sizeDetailsIndex: 0,
            firstLaunch: false,
            firstLaunchMale: false,
            itemTypeList: [],
            itemTypes: [],
            itemAllSizes: [],
            itemCat: [],
            bodyDetailsSaved: false,
            bodyDetailsSavedMale: false,
            modelSize: '',
            actions: actions,
            selectedSize: '',
            showButtons: true,
            addToBagWarningBool: false,
            alertDefault: false,
            addToBagSizeErrorBool: false,
            thumbnails: [],
            lipstickArr: [],
            modelDimMale: '',
            modelDim: '',
            modelHeight: '',
            modelMargin: '',
            //Popup State
            selectedPopupData: {
                headerIndex: 0,
                skinIndex: 3,
                skinIndexMale: 3,
                hairIndex: 1,
                hairIndexMale: 1,
                lipsIndex: 4,
                backDropIndex: 4,
                backDropIndexMale: 4,
            }
        };
    }
    componentWillReceiveProps(nextProps) {
        let _actions = this.state.actions;
        this.ownProps = nextProps.navigation && nextProps.navigation.getParam('ownProps', {});
        if (this.ownProps.addToBagCallback === 'success') {
            _actions[0].text = 'GO TO BAG';
            _actions[0].name = 'go_to_bag';
            goToBagArr.push(this.state.selectedSize); //Item already in bag
            let _addToBagWarningBool = false, _alertDefault = false;
            if (!this.state.is_male && !this.state.bodyDetailsSaved)
                _addToBagWarningBool = true;
            if (this.state.is_male && !this.state.bodyDetailsSavedMale)
                _addToBagWarningBool = true;
            else
                _alertDefault = true;
            this.setState({ addToBagWarningBool: _addToBagWarningBool, actions: _actions, alertDefault: _alertDefault, message: `Yay! Size ${this.state.selectedSize} added to bag` });
            setTimeout(() => {
                this.setState({ alertDefault: false });
            }, 2000);
        }
        else if (this.ownProps.isWishlisted) {
            _actions[1].text = 'GO TO WISHLIST';
            _actions[1].name = 'go_to_wishlist';
            this.setState({ addToBagWarningBool: false, actions: _actions });
        }
    }
    render() {
        const { is_male, displayFront, themeImg, wallBottomImg, modelFront, modelBack, shadowImg, middleImg, selectedPopupData, thumbnails, lipstickArr, modelHeight, modelMargin } = this.state;
        const femaleArr = thumbnails.skin ? [thumbnails.skin, thumbnails.hair, lipstickArr.lipstick ? lipstickArr.lipstick : thumbnails.lipstick, thumbnails.themes] : [];
        const maleArr = thumbnails.skin_male ? [thumbnails.skin_male, thumbnails.hair_male, thumbnails.themes] : [];
        const celebArr = thumbnails.celeb_hair ? [thumbnails.celeb_hair, thumbnails.celeb_lipstick, thumbnails.celeb_themes] : [];
        const selectedThemeObj = thumbnails.themes && thumbnails.themes.find((c) => c.id == selectedPopupData.backDropIndex);
        const backtransformStyle = {
            transform: [
                {
                    translateX: this.state.animationBack,
                },
            ],
        };
        const fronttransformStyle = {
            transform: [
                {
                    translateX: this.state.animationFront,
                },
            ],
        };
        return (react_1.default.createElement(react_native_1.View, { style: { flex: 1 } },
            react_1.default.createElement(react_native_1.SafeAreaView, { style: styles.topcontainer },
                react_1.default.createElement(ImageButton_1.default, { imagepath: require("../assets/images/letter-x.png"), width: 18, height: 18, marginLeft: 16, onPress: () => {
                        this.ownProps.logEvent(this.ownProps.uuid, SceneUtils_1.default.DISMISS_CLICK, ''); //Myntra log
                        let _actions = this.state.actions;
                        _actions[0].text = 'ADD TO BAG';
                        _actions[0].name = 'add_to_bag';
                        this.setState({ actions: _actions });
                        let recommendedSizes = null;
                        if (this.state.bodyDetailsSaved || this.state.bodyDetailsSavedMale) {
                            recommendedSizes = {};
                            if (this.state.sizeDetails && Array.isArray(this.state.sizeDetails) && this.state.sizeDetails[this.state.sizeDetailsIndex] && this.state.sizeDetails[this.state.sizeDetailsIndex].includes(';') && this.state.sizeDetails[this.state.sizeDetailsIndex].split(';')[0] !== 'NA')
                                recommendedSizes.tightFit = this.state.sizeDetails[this.state.sizeDetailsIndex].split(';')[0];
                            if (this.state.sizeDetails && Array.isArray(this.state.sizeDetails) && this.state.sizeDetails[this.state.sizeDetailsIndex] && this.state.sizeDetails[this.state.sizeDetailsIndex].includes(';') && this.state.sizeDetails[this.state.sizeDetailsIndex].split(';')[1] !== 'NA')
                                recommendedSizes.recommendedFit = this.state.sizeDetails[this.state.sizeDetailsIndex].split(';')[1];
                            if (this.state.sizeDetails && Array.isArray(this.state.sizeDetails) && this.state.sizeDetails[this.state.sizeDetailsIndex] && this.state.sizeDetails[this.state.sizeDetailsIndex].includes(';') && this.state.sizeDetails[this.state.sizeDetailsIndex].split(';')[2] !== 'NA')
                                recommendedSizes.looseFit = this.state.sizeDetails[this.state.sizeDetailsIndex].split(';')[2];
                        }
                        this.props.closePopup(recommendedSizes);
                    } }),
                react_1.default.createElement(react_native_1.View, { style: { marginRight: 16, width: 40, height: 40, flex: 1, flexDirection: 'row', justifyContent: 'flex-end' } },
                    react_1.default.createElement(react_native_1.Image, { source: { uri: `${SceneUtils_1.default.BASE_URL}/assets/images/logo.png` }, style: { width: 40, height: 40 } }))),
            react_1.default.createElement(react_native_1.Animated.View, { style: [styles.animatedBox, backtransformStyle] },
                react_1.default.createElement(react_native_1.View, { style: {
                        position: "absolute",
                        flex: 1,
                        height: "80%",
                        width: "10%",
                        backgroundColor: "#ddd",
                        left: -40,
                        zIndex: 5,
                    } }),
                react_1.default.createElement(react_native_1.View, { style: {
                        position: "absolute",
                        flex: 1,
                        height: "80%",
                        width: "10%",
                        backgroundColor: "#ddd",
                        right: 0,
                        zIndex: 5,
                    } }),
                react_1.default.createElement(react_native_1.View, { style: styles.leftRect }),
                react_1.default.createElement(react_native_1.View, { style: styles.rightRect }),
                themeImg != "" && (react_1.default.createElement(react_native_1.Image, { style: {
                        position: "absolute",
                        flex: 1,
                        height: "100%",
                        width: "100%",
                        bottom: 10
                    }, source: { uri: themeImg } })),
                wallBottomImg != "" && (react_1.default.createElement(react_native_1.Image, { style: {
                        position: "absolute",
                        flex: 1,
                        height: "20%",
                        width: "100%",
                        bottom: 0,
                        marginLeft: -20,
                        zIndex: 4,
                    }, source: { uri: wallBottomImg } })),
                modelBack != "" && selectedThemeObj && selectedThemeObj.withmirror && (react_1.default.createElement(react_native_1.Image, { style: {
                        position: "absolute",
                        flex: 1,
                        height: "45%",
                        width: "100%",
                        right: '20%',
                        marginTop: '40%',
                        resizeMode: 'contain'
                    }, source: displayFront ? { uri: modelBack } : { uri: modelFront } })),
                middleImg != "" && (react_1.default.createElement(react_native_1.Image, { style: {
                        position: "absolute",
                        flex: 1,
                        height: "90%",
                        width: "100%",
                    }, source: { uri: middleImg } }))),
            react_1.default.createElement(react_native_1.Animated.View, { style: [styles.animatedBox, fronttransformStyle] },
                modelFront != "" && (react_1.default.createElement(react_native_1.Image, { style: {
                        position: "absolute",
                        flex: 1,
                        height: modelHeight,
                        width: "100%",
                        left: '10%',
                        marginTop: modelMargin,
                        resizeMode: 'contain'
                    }, source: displayFront ? { uri: modelFront } : { uri: modelBack } })),
                shadowImg != "" && (react_1.default.createElement(react_native_1.Image, { style: {
                        position: "absolute",
                        height: "100%",
                        width: "100%",
                    }, source: { uri: shadowImg } })),
                react_1.default.createElement(react_native_1.TouchableOpacity, { style: { position: 'absolute', height: 38, width: 38, top: '65%', left: '30%' }, onPress: () => {
                        SceneUtils_1.default.callLogEventTNB(this.ownProps.uuid, SceneUtils_1.default.LEFT_ARROW_CLICKED, `{styleID: ${this.ownProps.styleid}, sessionID: ${this.ownProps.sessionid}, deviceID: ${this.ownProps.deviceid}}`); //TNB log
                        this.setState({ displayFront: displayFront ? false : true });
                    } },
                    react_1.default.createElement(react_native_1.Image, { style: { height: 38, width: 38 }, source: require('../assets/images/arrow_left.png') })),
                react_1.default.createElement(react_native_1.TouchableOpacity, { style: { position: 'absolute', height: 38, width: 38, top: '65%', right: '15%', transform: [{ rotate: '180deg' }] }, onPress: () => {
                        SceneUtils_1.default.callLogEventTNB(this.ownProps.uuid, SceneUtils_1.default.RIGHT_ARROW_CLICKED, `{styleID: ${this.ownProps.styleid}, sessionID: ${this.ownProps.sessionid}, deviceID: ${this.ownProps.deviceid}}`); //TNB log
                        this.setState({ displayFront: displayFront ? false : true });
                    } },
                    react_1.default.createElement(react_native_1.Image, { style: { height: 38, width: 38 }, source: require('../assets/images/arrow_left.png') }))),
            react_1.default.createElement(react_native_1.SafeAreaView, { style: styles.container },
                this.state.addToBagWarningBool && this.renderAddToBagWarning(),
                this.state.addToBagSizeErrorBool && this.renderAddToBagSizeError(),
                this.state.alertDefault && this.renderAlert(),
                !this.state.is_male && this.state.firstLaunch && !this.state.addToBagWarningBool && !this.state.addToBagSizeErrorBool && this.renderPopup(),
                this.state.is_male && this.state.firstLaunchMale && !this.state.addToBagWarningBool && !this.state.addToBagSizeErrorBool && this.renderPopupMale(),
                this.state.showButtons &&
                    react_1.default.createElement(react_1.default.Fragment, null,
                        react_1.default.createElement(react_native_1.View, { style: styles.customcontainer },
                            react_1.default.createElement(react_native_1.View, { style: [styles.iconContainer, { marginBottom: 8 }] },
                                react_1.default.createElement(ImageButton_1.default, { imagepath: require("../assets/images/body_shape.png"), width: 42, height: 42, imgWidth: 34, backgroundColor: "#fff", borderRadius: 21, onPress: () => this.editBody() }),
                                react_1.default.createElement(react_native_1.View, { style: styles.customtextView },
                                    react_1.default.createElement(react_native_1.Text, { style: styles.customtext }, "Personalise"))),
                            react_1.default.createElement(react_native_1.View, { style: [styles.iconContainer, { marginBottom: 8 }] },
                                this.state.selectedSize && this.state.selectedSize == undefined && this.state.selectedSize === '' ?
                                    react_1.default.createElement(ImageButton_1.default, { imagepath: require("../assets/images/size.png"), width: 42, height: 42, imgWidth: 34, backgroundColor: "#fff", borderRadius: 21, 
                                        //shadowColor={SceneUtils.text_color_4}
                                        //shadowOpacity={0.9}
                                        //elevation={2}
                                        onPress: () => this.onImageButtonClicked("size") }) : react_1.default.createElement(react_native_1.TouchableOpacity, { style: { width: 42, height: 42, backgroundColor: 'white', borderRadius: 21, justifyContent: 'center', alignItems: 'center', padding: 1 }, onPress: () => this.onImageButtonClicked("size") },
                                    react_1.default.createElement(react_native_1.Text, { style: { fontSize: 18, fontFamily: SceneUtils_1.default.whitney_semibold } }, this.state.selectedSize)),
                                react_1.default.createElement(react_native_1.View, { style: styles.customtextView },
                                    react_1.default.createElement(react_native_1.Text, { style: styles.customtext }, "Size"))),
                            react_1.default.createElement(react_native_1.View, { style: [styles.iconContainer, { marginBottom: 8 }] },
                                react_1.default.createElement(ImageButton_1.default, { imagepath: require("../assets/images/customize.png"), width: 42, height: 42, imgWidth: 34, backgroundColor: "#fff", borderRadius: 21, 
                                    // shadowOpacity={0.9}
                                    // elevation={2}
                                    onPress: () => this.onImageButtonClicked("customize") }),
                                react_1.default.createElement(react_native_1.View, { style: styles.customtextView },
                                    react_1.default.createElement(react_native_1.Text, { style: styles.customtext }, "Customize"))))),
                this.state.showBottomPopup && (react_1.default.createElement(BottomPopup_1.default, { headerArr: !this.state.bodyDetailsSaved && !this.state.is_male ? [
                        "Hair and Face",
                        "Lip Color",
                        "Backdrop",
                    ] : (this.state.is_male ?
                        [
                            "Skin Tone",
                            "Hair and Face",
                            "Backdrop"
                        ] : [
                        "Skin Tone",
                        "Hair and Face",
                        "Lip Color",
                        "Backdrop",
                    ]), onCrossPress: () => {
                        SceneUtils_1.default.callLogEventTNB(this.ownProps.uuid, SceneUtils_1.default.CUSTOMISE_CLOSE_CLICK, `{styleID: ${this.ownProps.styleid}, sessionID: ${this.ownProps.sessionid}, deviceID: ${this.ownProps.deviceid}}`); //TNB log
                        this.setState({
                            showBottomPopupSize: false,
                            showBottomPopup: false,
                            showButtons: true
                        });
                    }, onHeaderItemClick: this.onHeaderItemClick, selectedPopupData: this.state.selectedPopupData, nobodyDetailsSavedBool: !this.state.bodyDetailsSaved && !is_male, is_male: is_male, data: !this.state.bodyDetailsSaved && !this.state.is_male ?
                        celebArr[this.state.selectedPopupData["headerIndex"]] :
                        (this.state.is_male
                            ? maleArr[this.state.selectedPopupData["headerIndex"]]
                            : femaleArr[this.state.selectedPopupData["headerIndex"]]) })),
                this.state.showBottomPopupSize && (react_1.default.createElement(BottomPopupSize_1.default, { onCrossPress: () => {
                        SceneUtils_1.default.callLogEventTNB(this.ownProps.uuid, SceneUtils_1.default.SIZE_CLOSE_CLICK, `{styleID: ${this.ownProps.styleid}, sessionID: ${this.ownProps.sessionid}, deviceID: ${this.ownProps.deviceid}}`); //TNB log
                        this.setState({
                            showBottomPopupSize: false,
                            showBottomPopup: false,
                            showButtons: true
                        });
                    }, onSizeClicked: this.onSizeClicked, data: this.state.available_sizes, sizeDetails: this.state.sizeDetails, sizeDetailsIndex: this.state.sizeDetailsIndex, showSizeDetails: this.showSizeDetails, firstLaunch: this.state.firstLaunch, firstLaunchMale: this.state.firstLaunchMale, goToBodyShape: this.editBody, dismissPopup: this.dismissPopup, itemCat: this.state.itemCat, itemTypes: this.state.itemTypes, itemTypeList: this.state.itemTypeList, modelSize: this.state.modelSize, selectedSize: this.state.selectedSize, nobodyDetailsSavedBool: !this.state.bodyDetailsSaved && !is_male })))));
    }
}
exports.default = Scene;
const styles = react_native_1.StyleSheet.create({
    container: {
        flex: 1,
        padding: 15,
        // marginLeft: 15,
        position: 'absolute',
        bottom: 0,
        width: '100%',
    },
    topcontainer: {
        flexDirection: "row",
        marginTop: 12,
        marginLeft: 14,
        zIndex: 1
    },
    customcontainer: {
        flexDirection: "row",
        alignItems: "flex-end",
        marginLeft: 12
    },
    iconContainer: {
        justifyContent: "center",
        alignItems: "center",
        width: 65,
    },
    customtextView: {
        backgroundColor: SceneUtils_1.default.text_color,
        borderRadius: 12,
        borderWidth: 0.5,
        marginTop: 5,
        minWidth: 50
    },
    customtext: {
        justifyContent: "center",
        alignItems: "center",
        fontSize: 11,
        marginHorizontal: 5,
        marginVertical: 4,
        color: 'white',
        fontFamily: SceneUtils_1.default.whitney_book,
        textAlign: 'center'
    },
    animatedBox: {
        position: "absolute",
        flex: 1,
        height: "100%",
        width: "100%",
    },
    leftRect: {
        position: "absolute",
        flex: 1,
        top: "80%",
        left: -40,
        width: 0,
        height: 0,
        borderLeftWidth: 0,
        borderRightWidth: 40,
        borderTopWidth: 320,
        borderStyle: "solid",
        backgroundColor: "transparent",
        borderLeftColor: "transparent",
        borderRightColor: "transparent",
        borderTopColor: "#ddd",
        zIndex: 10,
    },
    rightRect: {
        position: "absolute",
        flex: 1,
        top: "80%",
        right: 0,
        width: 0,
        height: 0,
        borderLeftWidth: 41,
        borderRightWidth: 0,
        borderTopWidth: 320,
        borderStyle: "solid",
        backgroundColor: "transparent",
        borderLeftColor: "transparent",
        borderRightColor: "transparent",
        borderTopColor: "#ddd",
        zIndex: 10,
    },
    suggestionContainer: {
        backgroundColor: SceneUtils_1.default.text_color,
        borderRadius: 5,
        marginBottom: 28,
        padding: 15,
        paddingBottom: 21,
        marginHorizontal: 15,
    },
    suggestionText: {
        fontSize: 14,
        color: '#fff',
        lineHeight: 19,
        marginBottom: 10,
        fontFamily: SceneUtils_1.default.whitney_semibold
    },
    suggestionAction: {
        fontSize: 14,
        color: SceneUtils_1.default.primary_color,
        marginTop: 7,
        fontFamily: SceneUtils_1.default.whitney_semibold
    },
    modelSizeContainer: {
        flex: 1,
        flexDirection: 'row',
        marginTop: 5
    },
    sizeListContainer: {
        flex: 0.5,
        marginLeft: 19,
        marginBottom: 30,
        marginTop: 14
    },
    sizeListLabel: {
        fontSize: 14,
        color: SceneUtils_1.default.text_color
    }
});
//# sourceMappingURL=Scene.js.map