"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Shapes = [{ id: 1, images: ['assets/images/shapes/s1.png', 'assets/images/shapes/s2.png', 'assets/images/shapes/s3.png', 'assets/images/shapes/s4.png'] },
    { id: 2, images: ['assets/images/shapes/a1.png', 'assets/images/shapes/a2.png', 'assets/images/shapes/a3.png', 'assets/images/shapes/a4.png'] },
    { id: 3, images: ['assets/images/shapes/p1.png', 'assets/images/shapes/p2.png', 'assets/images/shapes/p3.png', 'assets/images/shapes/p4.png'] },
    { id: 4, images: ['assets/images/shapes/h1.png', 'assets/images/shapes/h2.png', 'assets/images/shapes/h3.png', 'assets/images/shapes/h4.png'] },
    { id: 5, images: ['assets/images/shapes/i1.png', 'assets/images/shapes/i2.png', 'assets/images/shapes/i3.png', 'assets/images/shapes/i4.png'] }
];
const heightFeetOptions = [{ label: '4', value: '4' }, { label: '5', value: '5' }, { label: '6', value: '6' }];
const heightInchOptions = [
    { label: '0', value: '0' },
    { label: '1', value: '1' },
    { label: '2', value: '2' },
    { label: '3', value: '3' },
    { label: '4', value: '4' },
    { label: '5', value: '5' },
    { label: '6', value: '6' },
    { label: '7', value: '7' },
    { label: '8', value: '8' },
    { label: '9', value: '9' },
    { label: '10', value: '10' },
    { label: '11', value: '11' }
];
const bandSize = [
    '28',
    '30',
    '32',
    '34',
    '36',
    '38',
    '40',
    '42',
    '44',
    '46',
    '48',
    '50',
    '52',
    '54',
    '56',
    '58',
    '60',
];
const chestSize = [
    '38',
    '40',
    '42',
    '44',
    '46',
    '48',
    '50',
    '52',
    '54',
    '56',
    '58',
    '60',
];
const cupSize = ['AA', 'A', 'B', 'C', 'D', 'DD', 'E', 'F'];
const waistOption = [
    { label: 'Auto', value: 'Auto' },
    { label: '22', value: '22' },
    { label: '23', value: '23' },
    { label: '24', value: '24' },
    { label: '25', value: '25' },
    { label: '26', value: '26' },
    { label: '27', value: '27' },
    { label: '28', value: '28' },
    { label: '29', value: '29' },
    { label: '30', value: '30' },
    { label: '31', value: '31' },
    { label: '32', value: '32' },
    { label: '33', value: '33' },
    { label: '34', value: '34' },
    { label: '35', value: '35' },
    { label: '36', value: '36' },
    { label: '37', value: '37' },
    { label: '38', value: '38' },
    { label: '39', value: '39' },
    { label: '40', value: '40' },
    { label: '41', value: '41' },
    { label: '42', value: '42' },
    { label: '43', value: '43' },
    { label: '44', value: '44' },
    { label: '45', value: '45' },
    { label: '46', value: '46' }
];
const hipOption = [
    { label: 'Auto', value: 'Auto' },
    { label: '30', value: '30' },
    { label: '31', value: '31' },
    { label: '32', value: '32' },
    { label: '33', value: '33' },
    { label: '34', value: '34' },
    { label: '35', value: '35' },
    { label: '36', value: '36' },
    { label: '37', value: '37' },
    { label: '38', value: '38' },
    { label: '39', value: '39' },
    { label: '40', value: '40' },
    { label: '41', value: '41' },
    { label: '42', value: '42' },
    { label: '43', value: '43' },
    { label: '44', value: '44' },
    { label: '45', value: '45' },
    { label: '46', value: '46' },
    { label: '47', value: '47' },
    { label: '48', value: '48' },
    { label: '49', value: '49' },
    { label: '50', value: '50' },
    { label: '51', value: '51' },
    { label: '52', value: '52' },
    { label: '53', value: '53' },
    { label: '54', value: '54' },
    { label: '55', value: '55' },
    { label: '56', value: '56' },
    { label: '57', value: '57' },
    { label: '58', value: '58' },
    { label: '59', value: '59' },
    { label: '60', value: '60' }
];
const body_shape = [
    { id: 1, name: 'Rectangle' },
    { id: 2, name: 'Apple' },
    { id: 3, name: 'Pear' },
    { id: 4, name: 'Hourglass' },
    { id: 5, name: 'Inverted Triangle' },
];
const male_max_weight = 150;
const male_min_weight = 40;
const female_max_weight = 120;
const female_min_weight = 30;
const bodyShapeMatrix = [
    { id: 1, name: 'Rectangle', waist_min: 0.94, waist_max: 1, hip_min: 0.97, hip_max: 1.05 },
    { id: 2, name: 'Apple', waist_min: 0.98, waist_max: 1.03, hip_min: 0.97, hip_max: 1.03 },
    { id: 3, name: 'Pear', waist_min: 0.98, waist_max: 1.05, hip_min: 1.05 },
    { id: 4, name: 'Hourglass', waist_max: 0.82, hip_min: 0.95, hip_max: 1.05 },
    { id: 5, name: 'Inverted Triangle', waist_min: 0.95, waist_max: 1.07, hip_max: 0.93 }
];
exports.default = {
    Shapes,
    heightFeetOptions,
    heightInchOptions,
    bandSize,
    chestSize,
    cupSize,
    waistOption,
    hipOption,
    male_max_weight,
    male_min_weight,
    female_max_weight,
    female_min_weight,
    body_shape,
    bodyShapeMatrix
};
//# sourceMappingURL=BodyUtils.js.map